
/*
 * A test program for GeekOS user mode
 */

#include "libuser.h"

int main(void)
{
    int rc, readFd=0, writeFd=0;
    int sink, source;

    rc = Create_Named_Pipe("pipe1", &readFd, &writeFd);
    if ( rc != 0 )
    {
    	Print("Create_Named_Pipe failed... %d\n", rc);
    	return rc;
    }
    
    Print("create named pipe returned %d and %d\n", readFd, writeFd);

    source = Spawn_Program ("/c/cat.exe", "/c/cat.exe /d/file1", 0, writeFd);
    sink   = Spawn_Program ("/c/wc.exe", "/c/wc.exe", readFd, 1);

    Wait(sink);
    Close(readFd);
    Wait(source);
    Close(writeFd);

    return 0;
}
